apiVersion: v1
kind: Pod
metadata:
  name: react-app-pod-affinity
  namespace: ns-prod
  labels:
    tier: prod
    affinity: podAffinity
spec:
  containers:
  - name: react-app-pod
    image: vuvanthanhtb/k8s-react-app:prod
    ports:
      - containerPort: 80
    livenessProbe:
      httpGet:
        path: /
        port: 80
      initialDelaySeconds: 30
      periodSeconds: 10
      failureThreshold: 3
    readinessProbe:
      httpGet:
        path: /
        port: 80
      initialDelaySeconds: 5
      periodSeconds: 5
      failureThreshold: 1
  nodeSelector:
    kubernetes.io/arch: amd64
    kubernetes.io/os: linux
    tier: prod
  affinity:
    podAffinity:
      requiredDuringSchedulingIgnoredDuringExecution:
      - labelSelector:
          matchExpressions:
          - key: tier
            operator: In
            values:
            - prod
        topologyKey: "kubernetes.io/hostname" # apply cloud -> zone
    podAntiAffinity:
      requiredDuringSchedulingIgnoredDuringExecution:
      - labelSelector:
          matchExpressions:
          - key: tier
            operator: NotIn
            values:
            - dev
            - prod
        topologyKey: "kubernetes.io/hostname" # apply cloud -> zone
